﻿/* ----------------------------------------------- */
/* ---------- Hide Change Status Task ------------ */
/* ----------------------------------------------- */
app.custom.formTasks.add('Incident', null, function (formObj, viewModel) {
	formObj.boundReady(function(){
	
		$( ".taskmenu li:contains('Change Status')" ).hide() 
		 
	});
	return;
}); 
/* ----------------------------------------------- */
/* --------- END Hide Change Status Task --------- */
/* ----------------------------------------------- */

/* ----------------------------------------------- */
/* ---------------- Resolve Task ----------------- */
/* ----------------------------------------------- */

// Set permissions for the task
app.custom.formTasks.add('Incident', null, function (formObj, viewModel) {
	formObj.boundReady(function(){
		var vm = pageForm.viewModel;
		//If the user is not an analyst, hide the task
		if (!session.user.Analyst || vm.Status.Name == "Resolved" || vm.Status.Name == "Closed") { 
			$( ".taskmenu li:contains('Resolve Incident')" ).hide() 
		} 
	});
	return;
});


app.custom.formTasks.add('Incident', "Resolve Incident", function (formObj, viewModel) {
	
	var resolutionenumid = "72674491-02cb-1d90-a48f-1b269eb83602"; //incident resolution category enum
	
	$.ajax({
		url: "/api/V3/Enum/GetList",
		data: {Id: resolutionenumid},
		type: "GET",
		success: function (resolutiondata) {
			console.log (resolutiondata)
			//Call the ResolveIR Function and send it the IR Resolution Categories Names and Id's
			ResolveIR(resolutiondata);
			
		}
	});
	
	//Quick Resolve
	function ResolveIR (resolutiondata){
	//use requirejs to load the HTML template first
	console.log (resolutiondata)
	require(["text!/CustomSpace/customtasks.irresolve.html"], function (template) {
		//make a jQuery obj
		cont = $(template);
			
		//create a view model to handle the UX
		var _vmWindow = new kendo.observable({
			resolutiondropDownData: resolutiondata,
			resValueChanged : function(e) {
				var dataItem = e.sender.dataItem();
				console.log (dataItem.Text)
				console.log (dataItem.Id)
			},
			resDescription: "",
            okEnabled: false,
            charactersRemaining: "4000",
            textCounter: function () {
                var maximumLength = 4000;
                var val = this.resDescription.length;
                (val > maximumLength) ? this.resDescription.substring(0, maximumLength) : this.set("charactersRemaining", maximumLength - val);
                (val > 19) ? this.set("okEnabled", true) : this.set("okEnabled", false);
            },
			okClick: function () {
				var resCategoryId = $("#resCategorySelected option:selected").val();
				console.log(resCategoryId);
				var resDescription = this.get("resDescription");

				//They clicked OK now call the Resolve Incident function and send the Resolution Category ID that is selected
				resolveIncident(resCategoryId, resDescription);
				customWindow.close();
				app.lib.mask.apply('Your Incident has been resolved! Please make any other changes that are necessary, then click Save or Apply to complete the process.');
				customWindow.close();
				
			},
			cancelClick: function () {
				customWindow.close();

			}
		});
	 
		//create the kendo window
		customWindow = cont.kendoWindow({
			title: "Resolve Incident",
			resizable: false,
			modal: true,
			viewable: false,
			width: 500,
			height: 400,
			close: function () {
	 
			},
			activate: function () {
				//on window activate bind the view model to the loaded template content
				kendo.bind(cont, _vmWindow);
			}
		}).data("kendoWindow");
		
		//now open the window
		customWindow.open().center();
		
	});
	}
	
	// Resolve
	function resolveIncident (categoryid, description) {
		var incident = pageForm.viewModel;
		
		incident.Status.set("Id", "2b8830b6-59f0-f574-9c2a-f4b4682f1681");
		incident.set("ResolutionDescription",description);
		incident.ResolutionCategory.set("Id",categoryid);
		
		var uid = session.user.Id;
		var displayname = session.user.Name;
		
		//set the resolved date
		pageForm.viewModel.set("ResolvedDate", (new Date().toISOString().split(".")[0]));
		
		//add a new comment to the action log about this being resolved
		incident.AppliesToTroubleTicket = [{
			"ActionType": {
			  "Id": "5ca2cfee-6740-1576-540B-ce17222840b8",
			  "Name": "Record Resolved"
				},	
			"Description": description,
			"EnteredBy": displayname,
			"EnteredDate": new Date().toISOString().split(".")[0],
			"LastModified": new Date().toISOString().split(".")[0],
			"Title": "Record Resolved",
			"Image": "/Content/Images/Icons/ActionLogIcons/recordresolved.png",
			"BillableTime": {
			  "BasedId": null,
			  "DisplayName": null
				},
			"LastUpdatedDisplay": null		
			}];
			
		incident.RelatesToTroubleTicket = [{
			"ClassTypeId": "eca3c52a-f273-5cdc-f165-3eb95a2b26cf",
			"BaseId": uid,
			"DisplayName": displayname
		}];
	}
	

});
/* ----------------------------------------------- */
/* -------------- END Resolve Task --------------- */
/* ----------------------------------------------- */